# Makefile for "lite" NASM 0.98.39 (circa 2005)
#
# using "freeware" Turbo C++ 1.01 (DOS)

.AUTODEPEND

!if !$d(CC) # you can "set CC=bcc" (etc.) instead of -DCC=bcc
CC = tcc
!endif

!if !$d(P6) # only 2 kb extra, so why not?
P6 = b p6
NASMCRC = F8C7B792
!else
NASMCRC = DAC710B5
!endif

!if !$d(MODEL)
MODEL = l
!endif

!if !$d(ANSI)
ANSI = -A
!endif

!if !$d(OPTJUMP)
OPTJUMP = -O
!endif

!if !$d(MERGESTR)
MERGESTR = -d
!endif

!if !$d(ALIGN)
ALIGN = -a
!endif

!if !$d(SPEED) # bloats up by 6 kb for questionable benefit
#SPEED = -G
!endif

!if !$d(NOFLOAT)
NOFLOAT = -f-
!endif

!if !$d(WARN)
WARN = -w-
!endif

# -DCFLAGS=... won't allow spaces
# response file (@cflags.txt) here is annoying
!if !$d(CFLAGS)
CFLAGS = -m$(MODEL) $(ANSI) $(OPTJUMP) $(MERGESTR) $(ALIGN) $(SPEED)\
  $(NOFLOAT) $(WARN) -DOF_DOS
!endif

!if !$d(MAP)
MAP = -M
!endif

!if !$d(LDFLAGS)
LDFLAGS = -m$(MODEL) $(NOFLOAT) $(MAP)
!endif

!if !$d(SED)
SED = sed
!endif

!if !$d(PACKEXE)
PACKEXE  = upx-nrv -qq --ultra-brute --8086
#PACKEXE = diet -X
!endif

!if !$d(CRC32)
CRC32 = crc32
!endif

.c.obj:
  $(CC) -c $(CFLAGS) {$* }

.c.c~:
  @ren $*.c *.c~
  @$(SED) -e "s/sn\(printf(.[^,]*\),.[^,]*\(.*\)/s\1\2/"\
    -e "s/__DATE__/\"I_dont_know\"/" $*.c~ >$*.c
  @-touch $*.c~ >NUL

NASMOBJS = nasm.obj nasmlib.obj float.obj insnsa.obj\
  assemble.obj labels.obj parser.obj outform.obj\
  preproc.obj listing.obj eval.obj\
  output\outbin.obj output\outobj.obj

FIXFILES = outform.h~ nasm.c~ listing.c~ labels.c~ preproc.c~\
  insnsa.c~ insnsi.h~ insnsn.c~

all: nasm.exe
  -$(PACKEXE) nasm.exe

clean:
  @del *.obj
  @del output\*.obj
  @del nasm.exe

nasm.exe: $(FIXFILES) $(NASMOBJS)
  $(CC) $(LDFLAGS) @&&%
  $(NASMOBJS)
%
  @echo $*.exe ...... $(NASMCRC)
  @-$(CRC32) $*.exe

outform.h~: outform.h
  @ren $*.h *.h~
  @$(SED) -e "s,^.def.* OF_[AW][LI][^ ]*,/* & */," $*.h~ >$*.h
  @-touch $*.h~ >NUL

output\outbin.obj: output\outbin.c
  $(CC) -c $(CFLAGS) -n$: $*
output\outobj.obj: output\outobj.c
  $(CC) -c $(CFLAGS) -n$: $*

insnsa.c~: insnsa.c
  @ren $*.c $*.c~
  @$(SED) -f &&%
/CMPSD.*IF_SSE2/d;/MOVSD.*IF_SSE2/d
s/_ADD[PS][DS]/_&/;s/_ADDSUBP[DS]/_&/;s/_ANDN*P[DS]/_&/;s/_CLFLUSH/_&/
s/_CMP[ELNOPU]/_&/;s/_CMPSS/_&/;s/_CVT[DPST]/_&/;s/_DIV[PS][DS]/_&/
s/_F*EMMS/_&/;s/_FISTTP/_&/;s/_HADDP[DS]/_&/;s/_HSUBP[DS]/_&/
s/_JMPE/_&/;s/_LDDQU/_&/;s/_LDMXCSR/_&/;s/_[LMS]FENCE/_&/
s/_MASKMOV/_&/;s/_MAX[PS][DS]/_&/;s/_MIN[PS][DS]/_&/;s/_MONITOR/_&/
s/_MOVAP[DS]/_&/;s/_MOV[DHLMNQU]/_&/;s/_MOVS[HLS]/_&/
s/_MUL[PS][DS]/_&/;s/_MWAIT/_&/;s/_ORP[DS]/_&/;s/_PACK[SU]/_&/
s/_PADD[BDQSUW]/_&/;s/_PANDN*/_&/;s/_PAUSE/_&/;s/_PAV[EG]/_&/
s/_PCMP[EG]/_&/;s/_PDISTIB/_&/;s/_PEXTRW/_&/;s/_PF2I[DW]/_&/
s/_PFA[CD]/_&/;s/_PFCMP[EG]/_&/;s/_PFM[AIU]/_&/;s/_PFP*NACC/_&/
s/_PFRCP/_&/;s/_PFRSQ/_&/;s/_PFSUBR*/_&/;s/_PI2F[DW]/_&/;s/_PINSRW/_&/
s/_PM[AIOUV]/_&/;s/_PX*OR/_&/;s/_PREFETCH/_&/;s/_PSADBW/_&/
s/_PSHUF[DHLW]/_&/;s/_PSLL[DQW]/_&/;s/_PSRA[DW]/_&/;s/_PSRL[DQW]/_&/
s/_PSUB[BDQ]/_&/;s/_PSUB[SUW]/_&/;s/_PSWAPD/_&/;s/_PUNPCK[HL]/_&/
s/_RCP[PS]S/_&/;s/_RDSHR/_&/;s/_RSDC/_&/;s/_RSLDT/_&/
s/_RSQRT[PS]S/_&/;s/_RSTS/_&/;s/_SHUFP[DS]/_&/;s/_SMINT/_&/
s/_SQRT[PS][DS]/_&/;s/_STMXCSR/_&/;s/_SUB[PS][DS]/_&/;s/_SV[DLT]/_&/
s/_U*COMIS/_&/;s/_UNPCK[HL]/_&/;s/_WRSHR/_&/;s/_XORP[DS]/_&/
s/_XSTORE/_&/
$(P6)
:p5
s/_F*CMOV/_&/;s/_FU*COM/_&/;s/_FX[RS]/_&/;s/_RDPMC/_&/;s/_SYS[CER]/_&/
:p6
/^ *instrux__/d;/__/!b
:fix
/};/d
N
s/.*\n//
b fix
% $*.c~ >$*.c
  @-touch $*.c~ >NUL

insnsi.h~: insnsi.h
  @ren $*.h $*.h~
  @$(SED) -f &&%
/MAX_INSLEN/s/ 11$/ 10/
/I_/!b
/_ADD[PS]/d;/_AND[NP]/d;/_CLFLUSH/d;/_CMP[ELNOP]/d;/_CMPSS/d
/_CMPUNORD/d;/_CVT[DPST]/d;/_DIV[PS]/d;/_F*EMMS/d;/_FISTTP/d;/_HADDP/d
/_HSUBP/d;/_JMPE/d;/_LDDQU/d;/_LDMXCSR/d;/_[LMS]FENCE/d;/_MASKMOV/d
/_MAX[PS]/d;/_MIN[PS]/d;/_MONITOR/d;/_MOV[ADHLMNQU]/d;/_MOVS[HLS]/d
/_MUL[PS]/d;/_MWAIT/d;/_ORP[DS]/d;/_PACK[SU]/d;/_PA[DN]D/d;/_PAUSE/d
/_PAV[EG]/d;/_PCMP[EG]/d;/_PDISTIB/d;/_PEXTRW/d;/_PF[2ACMNPRS]/d
/_PI2F/d;/_PINSRW/d;/_PMA[CDGX]/d;/_PMIN/d;/_PMOV/d;/_PMUL/d
/_PMV[GLNZ]/d;/_PX*OR/d;/_PREFETCH/d;/_PSADBW/d;/_PSHUF/d;/_PSLL/d
/_PSR[AL]/d;/_PSUB/d;/_PSWAPD/d;/_PUNPCK/d;/_RCP[PS]/d;/_RDSHR/d
/_RSDC/d;/_RSLDT/d;/_RSQRT/d;/_RSTS/d;/_SHUFP/d;/_SMINT/d;/_SQRT[PS]/d
/_STMXCSR/d;/_SUB[PS]/d;/_SV[DLT]/d;/_U*COMIS/d;/_UNPCK/d;/_WRSHR/d
/_XORP/d;/_XSTORE/d
$(P6)
:p5
/_F*CMOV/d;/_FU*COM/d;/_FX[RS]/d;/_RDPMC/d;/_SYS[CER]/d
:p6
% $*.h~ >$*.h
  @-touch $*.h~ >NUL

insnsn.c~: insnsn.c
  @ren $*.c $*.c~
  @$(SED) -f &&%
/add[ps][ds]/d;/and[pn]/d;/clflush/d;/cmp[elnopu]/d;/cmpss/d
/cvt[dpst]/d;/div[ps][ds]/d;/f*emms/d;/fisttp/d;/hadd/d;/hsub/d
/jmpe/d;/lddqu/d;/ldmxcsr/d;/[lms]fence/d;/maskmov/d;/max[ps]/d
/min[ps]/d;/monitor/d;/"mov[adhlmnqu]/d;/movs[hls]/d;/mul[ps][ds]/d
/mwait/d;/orp[ds]/d;/pack[su]/d;/padd/d;/pand/d;/pause/d;/pav[eg]/d
/pcmp[eg]/d;/pdistib/d;/pextrw/d;/pf[2acmnprs]/d;/pi2f/d;/pinsrw/d
/pma[cdgx]/d;/pmin/d;/pmov/d;/pmul/d;/pmv[glnz]/d;/px*or/d;/prefetch/d
/psadbw/d;/pshuf/d;/psll/d;/psr[al]/d;/psub/d;/pswapd/d;/punpck/d
/rcp[ps]/d;/rdshr/d;/rs[dl][cd]/d;/rsqrt/d;/rsts/d;/shufp/d;/smint/d
/sqrt[ps]/d;/stmxcsr/d;/sub[ps][ds]/d;/sv[dlt]/d;/u*comis/d;/unpck/d
/wrshr/d;/xorp/d;/xstore/d;/\"xor\",/s/,$//
$(P6)
:p5
/f*cmov/d;/fu*com/d;/fx[rs]/d;/rdpmc/d;/sys[cer]/d;/I_CMOVcc/d
:p6
% $*.c~ >$*.c
  @-touch $*.c~ >NUL

# EOF
